## crafty 15.20-2

=== Makefile ===
--- 
+++ 
@@ -1,3 +1,4 @@
+
 # To build crafty:
 #
 #         Uncomment the sections relevant to your architecture.
@@ -37,7 +38,10 @@
 #   2.  opt = -DCOMPACT_ATTACKS -DUSE_SPLIT_SHIFTS
 #   3.  opt = -DCOMPACT_ATTACKS -DUSE_SPLIT_SHIFTS -DUSE_ATTACK_FUNCTIONS
 #   
-
+#   Finally, if you have a Symmetric MultiProcessor machine, you should
+#   add -DSMP to the opt definition for your make configuration, and then
+#   add -DCPUS=N where N is the number of processors (max) you will use.
+#   
 # AIX
 #target  = AIX
 #CC      = cc
@@ -45,12 +49,16 @@
 #LDFLAGS =
 #opt     = -DCOMPACT_ATTACKS -DUSE_SPLIT_SHIFTS -DUSE_ATTACK_FUNCTIONS
 
+#opt     = -DCOMPACT_ATTACKS
 # ALPHA
 #target  = ALPHA
-#CC      = gcc
-#CFLAGS  = -O4
-#LDFLAGS =
-#opt     = -DCOMPACT_ATTACKS
+#CC      = cc
+#CFLAGS  = -O0 -pthread -newc -tune host
+#LDFLAGS = $(CFLAGS)
+#LIBS    = -lpthread -lexc
+##opt    = -DSMP -DCPUS=8 -DMUTEX -DFAST -DPOSIX
+#opt     = -DSMP -DCPUS=8 -DFAST -DPOSIX
+
 
 # DOS
 # target  = DOS
@@ -69,6 +77,14 @@
 #opt     = -DCOMPACT_ATTACKS -DUSE_SPLIT_SHIFTS -DUSE_ATTACK_FUNCTIONS \
 #          -DUSE_ASSEMBLY_A -DUSE_ASSEMBLY_B -DFAST
 
+# FreeBSD (pgcc)
+#target  = FreeBSD
+#CC      = gcc
+#CFLAGS  = -pipe -D_REENTRANT -mpentium -O -Wall
+#LDFLAGS = 
+#opt     = -DCOMPACT_ATTACKS -DUSE_SPLIT_SHIFTS -DUSE_ATTACK_FUNCTIONS \
+#          -DUSE_ASSEMBLY_A -DUSE_ASSEMBLY_B -DFAST
+
 # HP
 #target  = HP
 #CC      = cc
@@ -76,22 +92,24 @@
 #CFLAGS  = +ESlit -Ae +w1
 #LDFLAGS = $(OPT) $(CFLAGS)
 #opt     = 
- 
 
 # LINUX
 # Note: You have to uncomment exactly ONE of the `asm' lines below.
 target  = LINUX
 CC      = gcc
-CFLAGS  = -fomit-frame-pointer -O2 -Wall
-LDFLAGS = 
+DEB =	-DBOOKDIR=\"/usr/lib/games/crafty\" \
+	-DTBDIR=\"/usr/lib/games/crafty/TB\" \
+	-DLOGDIR=\".\"
+CFLAGS  = -pipe -D_REENTRANT -O3 -Wall $(DEB)
+LDFLAGS = -lpthread
 opt     = -DCOMPACT_ATTACKS -DUSE_SPLIT_SHIFTS -DUSE_ATTACK_FUNCTIONS \
-          -DFAST
+          -DUSE_ASSEMBLY_A -DUSE_ASSEMBLY_B -DFAST -DSMP -DCPUS=4
 
 # Uncomment the FIRST `asm' line for a.out systems.
 # Uncomment the SECOND `asm' line for ELF systems.
 #
 #asm     = X86-aout.o
-#asm     = X86-elf.o
+asm     = X86-elf.o
 
 # NEXT
 #target  = NEXT
@@ -125,21 +143,21 @@
 #CC      = cc
 #AFLAGS  = -P
 #CFLAGS  = -fast -xO5 -xunroll=20
-#LDFLAGS = 
+#LDFLAGS = -lpthread
 #opt     = -DCOMPACT_ATTACKS -DUSE_SPLIT_SHIFTS -DUSE_ATTACK_FUNCTIONS \
-#          -DUSE_ASSEMBLY_A
+#          -DUSE_ASSEMBLY_A -DSMP -DCPUS=4 -DMUTEX -DPOSIX
 #asm     = Sparc.o
 
 # Do not change anything below this line!
 
 opts = $(opt) -D$(target)
 
-objects = searchr.o search.o repeat.o next.o nextr.o history.o nexte.o        \
-        quiesce.o evaluate.o movgen.o make.o unmake.o lookup.o store.o        \
-        attacks.o swap.o boolean.o draw.o utility.o valid.o book.o data.o     \
-        drawn.o edit.o enprise.o epd.o epdglue.o init.o input.o interupt.o    \
-        iterate.o main.o option.o output.o phase.o ponder.o preeval.o         \
-        resign.o root.o learn.o setboard.o test.o time.o validate.o           \
+objects = searchr.o search.o thread.o searchmp.o repeat.o next.o nexte.o      \
+        nextr.o history.o quiesce.o evaluate.o movgen.o make.o unmake.o       \
+        lookup.o store.o attacks.o swap.o boolean.o draw.o utility.o valid.o  \
+        book.o data.o drawn.o edit.o enprise.o epd.o epdglue.o init.o input.o \
+        interupt.o iterate.o main.o option.o output.o phase.o ponder.o        \
+        preeval.o resign.o root.o learn.o setboard.o test.o time.o validate.o \
         annotate.o analyze.o evtest.o bench.o $(asm)
 
 includes = data.h chess.h
@@ -150,7 +168,7 @@
 
 crafty:	$(objects) 
 	@echo $(CC) $(LDFLAGS) -o crafty {object files} -lm
-	@$(CC) $(LDFLAGS) -o crafty $(objects) -lm
+	@$(CC) $(LDFLAGS) -o crafty $(objects) -lm  $(LIBS)
 	@rm -f X86-elf.S
 	@rm -f X86-aout.S
