=== debian/changelog ===
crafty (15.20-2) unstable; urgency=low

  * Corrected maintainer's address.

 -- Paul Serice <ugs@debian.org>  Sat, 17 Oct 1998 10:43:09 -0500

crafty (15.20-1) unstable; urgency=low

  * Added the book of opening moves.
  * Added a /etc/craftyrc global configuration file.
  * Moved Crafty into free.
  * Bug fix in upstream source that was causing crafty to crash
    if the position.lrn file was read only.
  * New upstream source.
  * New maintainer.

 -- Paul Serice <ugs@debian.org>  Sat,  3 Oct 1998 21:40:09 -0500

crafty (14.12-1) unstable; urgency=low

  * New upstream.

 -- Ole J. Tetlie <olet@debian.org>  Sat, 21 Mar 1998 13:16:11 +0100

crafty (14.11-2) frozen unstable; urgency=low

  * Added undocumented manpage.
  * Fixed bug in source distribution. (#19783)

 -- Ole J. Tetlie <olet@debian.org>  Fri, 20 Mar 1998 21:40:28 +0100

crafty (14.11-1) unstable; urgency=low

  * Initial debianization.

 -- Ole J. Tetlie <olet@debian.org>  Mon,  9 Mar 1998 11:24:27 +0100

Local variables:
mode: debian-changelog
End:
