=== debian/control ===
Source: crafty
Section: games
Priority: optional
Maintainer: Paul Serice <ugs@debian.org>
Standards-Version: 2.4.1

Package: crafty
Architecture: any
Depends: ${shlibs:Depends}
Suggests: xboard
Description: Chess playing program
 Crafty is a strong chess program. It performs better than gnuchess
 in most positions. Crafty is compatible with xboard and is updated
 frequently.
