## crafty 19.15

=== Makefile ===
# To build crafty:
#
#	  You want to set up for maximum optimization, but typically you will
#	  need to experiment to see which options provide the fastest code.
#	  This is optimized for gcc, which is a fairly current compiler.
#   
#   The currently available targets:
#
#     aix          {IBM machines running AIX}
#     alpha        {DEC Alpha running OSF/1-Digital Unix}
#     darwin       {PPC on Mac OSX}
#     freebsd      {80X86 architecture running FreeBSD (Unix)}
#     hpux         {HP workstation running HP_UX operating system (Unix)}
#     linux        {80X86 architecture running LINUX (Unix) (gcc)}
#     linux-alpha  {Digital Alpha processor running LINUX (Unix)}
#     linux-amd64  {AMD X86-64 (opteron) running LINUX (Unix)}
#     linux-icc    {80X86 architecture running LINUX (Unix) (Intel compiler)}
#     netbsd       {80X86 architecture running netbsd(Unix)}
#     netbsd-sparc {sparc architecture running netbsd(Unix)}
#     next         {NextStep}
#     os2          {IBM OS/2 warp}
#     sgi          {SGI Workstation running Irix (SYSV/R4) Unix}
#     solaris      {Sun SparcStation running Solaris (SYSV/R4) Unix}
#     solaris-gcc  {Sun SparcStation running Solaris but using gcc}
#   
#   The next options are optimizations inside Crafty that you will have
#   test to see if they help.  on some machines, these will slow things
#   by up to 10%, while on other machines these options will result in
#   improving search speed up to 20%.  NOTE:  if you are running Linux
#   system, the default configurations below will use the hand-written
#   assembly modules.  Typical performance improvement is 5%, but this
#   only applies to X86 machines running Linux.
#   
#   -DSMP             enables SMP support (not clustering).  If you choose
#                     this option, you need to look closely at the following
#                     four options as well.
#   -DCPUS=n          defines the maximum number of CPUS Crafty will be able
#                     to use in a SMP system.  Note that this is the max you
#                     will be able to use.  You need to use the smpmt=n command
#                     to make crafty use more than the default 1 thread.
#   -DPOSIX           This enables POSIX threads support.  You must have either
#                     -DPOSIX or custom-written lock.h code to support your 
#                     system.
#   -DMUTEX           This uses posix threads MUTEX locks, which are not as
#                     efficient as spinlocks, but are very portable.  If this
#                     option is not chosen, then lock.h has to be modified to
#                     define inline assembly lock functions.
#
#   -DBOOKDIR         path to the directory containing the book binary files.
#                     The default for all such path values is "." if you don't
#                     specify a path with this macro definition.
#   -DDETECTDRAW      This enables experimental code that detects lots of the
#                     famous blocked-pawn positions as draws.  It is much slower
#                     and perhaps slightly risky.
#   -DDGT             This is a unix-only option to support the DGT board.
#   -DEPD             if you want full EPD support built in.
#   -DFAST            This option compiles out some of the statistics 
#                     gathering to slightly speed up the code.
#   -DFUTILITY        enables "futility pruning" a forward-pruning algorithm
#                     that seems to be relatively safe.
#   -DLOGDIR          path to the directory where Crafty puts the log.nnn and
#                     game.nnn files.
#   -DRCDIR           path to the directory where we look for the .craftyrc or
#                     crafty.rc (windows) file.
#   -DTBDIR           path to the directory where the endgame tablebase files
#                     are found.  default = "./TB"
#   -DTRACE           This enables the "trace" command so that the search tree
#                     can be dumped while running.
#   -INLINE_AMD       Compiles with the Intel assembly code for FirstOne(),
#                     LastOne() and PopCnt() for the AMD opteron, only tested
#                     with the 64-bit opteron GCC compiler.
#   -INLINE_ASM       Compiles with the Intel assembly code for FirstOne(),
#                     LastOne() and PopCnt().  This is for gcc-style inlining
#                     and now works with the Intel C/C++ compiler as well.
#   

default:
	$(MAKE) -j linux-icc
help:
	@echo "You must specify the system which you want to compile for:"
	@echo ""
	@echo "make aix              IBM AIX"
	@echo "make alpha            DEC Alpha with OSF/1-Digital UNIX"
	@echo "make alpha-host       Alpha DECstation optimized for host"
	@echo "make alpha-host-nocix Alpha DECstation optimezed for host, no CIX insn"
	@echo "make darwin           Darwin on OSX"
	@echo "make hpux             HP/UX 9/10, /7xx"
	@echo "make linux            Linux optimized for i386, ELF format"
	@echo "make linux-alpha      Linux optimized for alpha"
	@echo "make linux-AMD64      Linux optimized for AMD opteron
	@echo "make freebsd          FreeBSD"
	@echo "make netbsd           NetBSD"
	@echo "make netbsd-sparc     NetBSD optimized for sparc"
	@echo "make next             NeXTSTEP"
	@echo "make os2              IBM OS/2 Warp"
	@echo "make sgi              SGI running IRIX"
	@echo "make solaris          Solaris 2.x"
	@echo "make solaris-gcc      Solaris 2.x using GNU cc"
	@echo ""
	@echo "make generic          Try this one if your system isn't listed above;"
	@echo "                      it assumes you have installed GNU cc"
	@echo ""

aix:
	$(MAKE) target=AIX \
		CC=cc CXX=$(CC) \
		CFLAGS='$(CFLAGS) -O2' \
		CXFLAGS=$(CFLAGS) \
		opt='$(opt) -DFUTILITY' \
		crafty-make

alpha:
	$(MAKE) target=ALPHA \
		CC=cc CXX=cxx \
		CFLAGS='$(CFLAGS) -std -fast -O4 -pthread -newc' \
		CXFLAGS=$(CFLAGS) \
		LDFLAGS='$(LDFLAGS) $(CFLAGS)' \
		LIBS='-lpthread -lexc' \
		opt='$(opt) -DFUTILITY -DSMP -DCPUS=8 -DFAST -DPOSIX' \
		crafty-make

alpha-host:
	$(MAKE) target=ALPHA \
		CC=cc CXX=cxx \
		CFLAGS='$(CFLAGS) -std -fast -O4 -pthread -newc -arch host' \
		CXFLAGS=$(CFLAGS) \
		LDFLAGS='$(LDFLAGS) $(CFLAGS)' \
		LIBS='-lpthread -lexc' \
		opt='$(opt) -DFUTILITY -DSMP -DCPUS=8 -DFAST -DPOSIX' \
		crafty-make

alpha-host-nocix:
	$(MAKE) target=ALPHA \
		CC=cc CXX=cxx \
		CFLAGS='$(CFLAGS) -std -fast -O4 -pthread -newc' \
		CXFLAGS='$(CFLAGS) -arch ev56 -tune host' \
		LDFLAGS='$(LDFLAGS) $(CFLAGS)' \
		LIBS='-lpthread -lexc' \
		opt='$(opt) -DFUTILITY -DSMP -DCPUS=8 -DFAST -DPOSIX' \
		crafty-make

darwin:
	$(MAKE) target=FreeBSD \
		CC=gcc CXX=g++ \
		CFLAGS='$(CFLAGS) -Wall -pipe -O3' \
		CXFLAGS=$(CFLAGS) \
		LDFLAGS=$(LDFLAGS) \
		LIBS='-lstdc++' \
		opt='$(opt) -DFUTILITY -DFAST' \
		crafty-make
		
freebsd:
	$(MAKE) target=FreeBSD \
		CC=gcc CXX='$(CC)' \
		CFLAGS='$(CFLAGS) -fomit-frame-pointer -m486 -O3 -Wall' \
		CXFLAGS=$(CFLAGS) \
		LDFLAGS=$(LDFLAGS) \
		opt='$(opt) -DFUTILITY -DUSE_ASSEMBLY -DFAST' \
		crafty-make

freebsd-pgcc:
	$(MAKE) target=FreeBSD \
		CC=gcc CXX='$(CC)' \
		CFLAGS='$(CFLAGS) -pipe -D_REENTRANT -mpentium -O -Wall' \
		CXFLAGS=$(CFLAGS) \
		LDFLAGS=$(LDFLAGS) \
		opt='$(opt) -DFUTILITY -DUSE_ASSEMBLY -DFAST' \
		crafty-make

hpux:
	$(MAKE) target=HP \
		CC=cc CXX='$(CC)' \
		CFLAGS='$(CFLAGS) +ESlit -Ae +w1' \
		CXFLAGS=$(CFLAGS) \
		LDFLAGS='$(LDFLAGS) +O3 +Onolimit $(CFLAGS)' \
		crafty-make

linux:
	$(MAKE) target=LINUX \
		CC=gcc CXX=g++ \
		CFLAGS='$(CFLAGS) -Wall -pipe -D_REENTRANT -march=i686 -O3 \
			-fbranch-probabilities -fforce-mem -fomit-frame-pointer\
			-fno-gcse -mpreferred-stack-boundary=2' \
		CXFLAGS=$(CFLAGS) \
		LDFLAGS='$(LDFLAGS) -lpthread -lstdc++' \
		opt='$(opt) -DFUTILITY -DFAST -DINLINE_ASM \
                         -DPOSIX -DSMP -DCPUS=2' \
		crafty-make

linux-amd64:
	$(MAKE) target=LINUX \
		CC=gcc CXX=g++ \
		CFLAGS='$(CFLAGS) -Wall -pipe -D_REENTRANT \
		-fomit-frame-pointer -O3' \
		CXFLAGS=$(CFLAGS) \
		LDFLAGS='$(LDFLAGS) -lpthread -lstdc++' \
		opt='$(opt) -DPOSIX -DFAST -DSMP -DCPUS=4 \
		         -DFUTILITY -DUSE_ASSEMBLY -DINLINE_AMD' \
		crafty-make

linux-profile:
	$(MAKE) target=LINUX \
		CC=gcc CXX=g++ \
		CFLAGS='$(CFLAGS) -Wall -pipe -D_REENTRANT -march=i686 -O3 \
			-fprofile-arcs -fforce-mem \
			-fno-gcse -mpreferred-stack-boundary=2' \
		CXFLAGS=$(CFLAGS) \
		LDFLAGS='$(LDFLAGS) -fprofile-arcs -lstdc++ -lpthread' \
		opt='$(opt) -DFUTILITY -DINLINE_ASM -DFAST \
		         -DPOSIX -DSMP -DCPUS=4' \
		crafty-make

linux-icc-profile:
	$(MAKE) target=LINUX \
		CC=icc CXX=icc \
		CFLAGS='$(CFLAGS) -D_REENTRANT -O2 \
                        -xN -prof_genx -prof_dir ./profdir \
                        -Ob2 -fno-alias' \
		CXFLAGS='$(CFLAGS) -D_REENTRANT -O2 \
                        -w -xN -prof_genx -prof_dir ./profdir' \
		LDFLAGS='$(LDFLAGS) -lpthread' \
		opt='$(opt) -DFUTILITY -DFAST -DINLINE_ASM \
                         -DPOSIX -DSMP -DCPUS=2' \
		crafty-make

linux-icc:
	$(MAKE) target=LINUX \
		CC=icc CXX=icc \
		CFLAGS='$(CFLAGS) -D_REENTRANT -O2 \
                        -xN -prof_use -prof_dir ./profdir \
                        -Ob2 -fno-alias' \
		CXFLAGS='$(CFLAGS) -D_REENTRANT -O2 \
                        -w -xN -prof_use -prof_dir ./profdir' \
		LDFLAGS='$(LDFLAGS) -lpthread' \
		opt='$(opt) -DFUTILITY -DFAST -DINLINE_ASM \
                         -DPOSIX -DSMP -DCPUS=2' \
		crafty-make

linux-alpha:
	$(MAKE) target=ALPHA \
		CC=gcc CXX=g++ \
		CFLAGS='$(CFLAGS) -O4 -ffast-math -funroll-loops' \
		CXFLAGS=$(CFLAGS) \
		LDFLAGS='$(LDFLAGS) $(CFLAGS)' \
		LIBS='-lpthread' \
		opt='$(opt) -DFUTILITY -DSMP -DCPUS=8 -DFAST -DPOSIX \
                         -DNOBUILTINS' \
		crafty-make

netbsd:
	$(MAKE) target=NetBSD \
		CC=gcc CXX=g++ \
		CFLAGS='$(CFLAGS) -D_REENTRANT -O3 -Wall \
			-fomit-frame-pointer -funroll-all-loops \
			-finline-functions -ffast-math' \
		CXFLAGS=$(CFLAGS) \
		LDFLAGS=$(LDFLAGS) \
		opt='$(opt) -DFUTILITY -DFAST' \
		crafty-make

netbsd-i386:
	$(MAKE) target=NetBSD \
		CC=gcc CXX=g++ \
		CFLAGS='$(CFLAGS) -D_REENTRANT -O3 -Wall -m486 \
			-fomit-frame-pointer -funroll-all-loops \
			-finline-functions -ffast-math' \
		CXFLAGS=$(CFLAGS) \
		LDFLAGS=$(LDFLAGS) \
		opt='$(opt) -DFUTILITY -DFAST -DUSE_ASSEMBLY' \
		crafty-make

netbsd-sparc:
	$(MAKE) target=NetBSD \
		CC=gcc CXX=g++ \
		CFLAGS='$(CFLAGS) -D_REENTRANT -O3 -Wall \
			-fomit-frame-pointer -funroll-all-loops \
			-finline-functions -ffast-math' \
		CXFLAGS=$(CFLAGS) \
		LDFLAGS=$(LDFLAGS) \
		opt='$(opt) -DFUTILITY -DFAST' \
		crafty-make

next:
	$(MAKE) target=NEXT \
		CC=/bin/cc CXX='$(CC)' \
		CFLAGS='$(CFLAGS) -O2' \
		CXFLAGS=$(CFLAGS) \
		LDFLAGS='$(LDFLAGS) $(CFLAGS)'
		opt='$(opt) -DFUTILITY' \
		crafty-make

os2:
	$(MAKE) target=OS2 \
		CC=gcc CXX='$(CC)' \
		CFLAGS='$(CFLAGS) -fomit-frame-pointer -m486 -O3 -Wall' \
		CXFLAGS=$(CFLAGS) \
		LDFLAGS='$(LDFLAGS) -Zexe -Zcrtdll -s' \
		opt='$(opt) -DFUTILITY -DUSE_ASSEMBLY -DFAST' \
		crafty-make

sgi:
	$(MAKE) target=SGI \
		AS=/bin/as CC=cc CXX='$(CC)' \
		AFLAGS='-P' \
		CFLAGS='$(CFLAGS) -32 -mips2 -cckr' \
		CXFLAGS=$(CFLAGS) \
		LDFLAGS=$(LDFLAGS) \
		opt='$(opt) -DFUTILITY' \
		crafty-make

solaris:
	$(MAKE) target=SUN \
		AS=/usr/ccs/bin/as CC=cc CXX='$(CC)' \
		AFLAGS='-P' \
		CFLAGS='$(CFLAGS) -fast -xO5 -xunroll=20' \
		CXFLAGS=$(CFLAGS) \
		LDFLAGS='$(LDFLAGS) -lpthread' \
		opt='$(opt) -DFUTILITY -DSMP -DCPUS=4 -DMUTEX -DPOSIX' \
		crafty-make

solaris-gcc:
	$(MAKE) target=SUN \
		AS=/usr/ccs/bin/as CC=gcc CXX=g++ \
		AFLAGS='-P' \
		CFLAGS='$(CFLAGS) -Wall -pipe -D_REENTRANT -O2 \
			-fforce-mem -fomit-frame-pointer' \
		CXFLAGS=$(CFLAGS) \
		LDFLAGS='$(LDFLAGS) -lstdc++' \
		opt='$(opt) -DFUTILITY -DFAST' \
		crafty-make

generic:
	$(MAKE) CC=gcc CXX=g++ \
		CXFLAGS=$(CFLAGS) \
		LDFLAGS=$(LDFLAGS) \
		crafty-make

profile:
	@rm -rf profdir
	@rm -rf position.bin
	@mkdir profdir
	@touch *.c *.cpp *.h
	$(MAKE) linux-icc-profile
